
Redmine - Feature #4939

List of tasks filtered as OR and not AND

2010-02-26 13:03 - Alain V.

Status: New Start date: 2010-02-26

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues filter Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

Hello

Up to now in the list of task you can filter upon some values but the list of filters are

List of tasks that has

filter1=value1 AND filter2=value2 AND filter3=value3

I think it could be interesting to have the possibility of

List of tasks that has

filter1=value1 OR filter2=value2 OR  filter3=value3

Do you think it is possible? thank you

Related issues:

Related to Redmine - Feature #10999: Ticket list filter: More flexible filter... New

Related to Redmine - Feature #41214: Allow the 'OR' Logical Operator in Query New

Has duplicate Redmine - Feature #7641: Issue filter with OR semantic addition... Closed 2011-02-17

Has duplicate Redmine - Feature #12970: Implement the "OR" operator in queries Closed

Has duplicate Redmine - Feature #6332: "OR" filter and not only "AND" filter Closed 2010-09-08

Has duplicate Redmine - Feature #10421: Filter with OR conditions Closed

Has duplicate Redmine - Feature #21532: Adding OR and XOR request to REST API... Closed

Has duplicate Redmine - Feature #23211: Issue filter menu should have differe... Closed

Has duplicate Redmine - Feature #23216: Issues List, Enhanced Filtering - All... Closed

Has duplicate Redmine - Feature #34793: Filter OR / AND for issues and repeat... Closed

Has duplicate Redmine - Feature #13356: Disjunction for issues filters Closed

History

#1 - 2010-02-26 17:16 - Jean-Philippe Lang

- Category set to Issues

#2 - 2010-04-06 01:40 - Andrew Sherman

+1. This would be useful for some filters I have tried to make as well.

#3 - 2010-04-14 00:11 - Jeremy Walker

+1 I would love it if Redmine had this functionality.  Perhaps the easiest/most powerful way to implement this would be to make a way for users to

create filters out of combinations of other filters.  In other words, if I could define filters A, B, and C, and then say something like "Give me all the

issues that are in A OR B, but not in C", I could get any issue list I could ever want.  And that would be awesome.

#4 - 2010-04-14 00:12 - Jeremy Walker

Jeremy Walker wrote:

+1 I would love it if Redmine had this functionality.  Perhaps the easiest/most powerful way to implement this would be to make a way for users

to create filter sets out of combinations of other filter sets.  In other words, if I could define filter sets A, B, and C, and then say something like

"Give me all the issues that are in A OR B, but not in C", I could get any issue list I could ever want.  And that would be awesome.
#5 - 2010-08-19 16:22 - Alain V.

Any progress on this subject guys? ;o)

#6 - 2011-02-18 11:20 - Matthias Neubert

+1

Thats nearly what I ment with #7641, but I'd like to combine AND and OR freely.

e.g. A AND B OR C AND D

should list all issues which fullfill both, A and B

plus the issue which fillfill both, C and D

Basically it should be read like disjunctive normal form

#7 - 2011-02-18 11:24 - Matthias Neubert

also this could be interesting when one wants to list all issues

assigned to me, and also all which aren't assigned yet.

for this feature a filtercriteria must be usable more than one time

or other solution: the list of possible assignees contains a special element "Not assigned" at the top of the list, so one can select (by multiple

selection) me and "Not assigned"

#8 - 2013-01-28 10:41 - Gurvan Le Dromaguet

It looks like it is implemented in "Trac": http://trac.edgewall.org/query, see the "OR" at the bottom right of the filters box

#9 - 2013-04-24 11:02 - Francesco V

Gurvan Le Dromaguet wrote:

It looks like it is implemented in "Trac": http://trac.edgewall.org/query, see the "OR" at the bottom right of the filters box

 I like it

#10 - 2013-05-15 13:53 - Daniel Felix

Yes this would be a good improvement. It won't be easy but a really cool addition to the current filter-system.

#11 - 2013-05-24 23:53 - Christian Baus

+1

any workaround here? we need a filter like "is autor or observer"

#12 - 2013-08-20 17:14 - Dani Leni

+1

Need Assignee or Watcher.

#13 - 2013-08-28 19:58 - Jean Carlos Gonçalves

+1

#14 - 2013-09-19 11:46 - Quan VN

- File Redmine using OR.zip added

Here is my quick and dirty solution. I am not a RoR developer and this is my very first attempt so that I can use Redmine for my job.

I hope that someone can make this into a full plugin. If you have any idea or find problem, please let me know. I will see if I can do anything. Thanks

#15 - 2013-09-19 11:53 - Christian Baus

Thanks for your patch! i look forward to implement that in our redmine!!

#16 - 2013-12-13 11:59 - Zbynek Drlik

+1
#17 - 2014-03-17 13:47 - Lu Su

+1

#18 - 2014-04-01 13:55 - Antoine Pichon

+1 (thanks for your excellent work)

#19 - 2014-04-24 10:49 - Toshi MARUYAMA

- Related to Feature #10421: Filter with OR conditions added

#20 - 2014-06-18 15:14 - Toshi MARUYAMA

- Related to deleted (Feature #10421: Filter with OR conditions)

#21 - 2014-06-18 15:14 - Toshi MARUYAMA

- Has duplicate Feature #10421: Filter with OR conditions added

#22 - 2014-06-26 21:20 - James H

+1

#23 - 2014-12-19 14:58 - Sebastian Paluch

Matthias Neubert wrote:

+1

Thats nearly what I ment with #7641, but I'd like to combine AND and OR freely.

e.g. A AND B OR C AND D

should list all issues which fullfill both, A and B

plus the issue which fillfill both, C and D

Basically it should be read like disjunctive normal form

 +1

so important feature and no progress for 5 years :(

#24 - 2014-12-19 17:35 - Jan Niggemann (redmine.org team member)

so important feature and no progress for 5 years :(

 We only have 2 programmers working in their spare time, plus contributions from a few other volunteers.

If you send patches that apply cleanly against current trunk (together with tests) we'd happily test and apply those.

#25 - 2015-10-16 09:37 - Istvan Heckl

+1

#26 - 2015-10-18 05:17 - Quan VN

I have made this patch into a plugins here (with some improvement). It works with redmine 2.6.x and 3.1.1 or less. Please use the plugin instead of

this patch

http://www.redmine.org/plugins/zquery

#27 - 2015-11-17 13:50 - Jānis Elmeris

+1

#28 - 2015-11-20 02:50 - Quan VN

- File _query.zip added

#29 - 2016-01-12 01:29 - Toshi MARUYAMA
- Has duplicate Feature #21532: Adding OR and XOR request to REST API and issue filters added

#30 - 2016-06-14 20:08 - Fred B

What is the difference between zquery and _query?

Did someone tested one with Redmine 2.4?

#31 - 2016-06-15 03:04 - Quan VN

Fred B wrote:

What is the difference between zquery and _query?

Did someone tested one with Redmine 2.4?

 Dear Fred

1. They are the same but I renamed zquery to _query so it is loaded first. _query is now the "official" version :-) (I have replace zquery attachment

with _query but the name is still in the link)

2. I think it should work with 2.3 upward since I developed it based on 2.3 version

Quan

#32 - 2016-06-30 17:52 - Toshi MARUYAMA

- Has duplicate Feature #23211: Issue filter menu should have different logical operators like "AND", "OR", ... added

#33 - 2016-06-30 17:52 - Toshi MARUYAMA

- Category changed from Issues to Issues filter

#34 - 2016-07-01 03:12 - Toshi MARUYAMA

- Has duplicate Feature #23216: Issues List, Enhanced Filtering - Allowing Multiple Queries & "OR"-type constraints added

#35 - 2016-07-08 11:33 - Anonymous

+1

#36 - 2017-05-14 14:29 - Iwadara I

+1

#37 - 2017-06-17 01:39 - Reto Stamm

+1

#38 - 2017-06-17 04:01 - Yuuki NARA

+1

#39 - 2017-07-24 10:04 - Santiago Torres

+1

#40 - 2017-10-26 02:18 - Shaun Gilroy

So is there any chance that the _query plugin getting updated to function with Redmine 3.4? I tried to figure out how to update it, but it's not clear to

me what needs to be changed to make it compatible.

It gives me the following error in 3.4 as is:

Showing /opt/redmine/app/views/queries/_filters.html.erb where line #4 raised:

undefined method `remote' for #<Hash:0x007fe319fa1de8>

Extracted source (around line #464):

462

463

464

465

466

467

    available_filters.each do |field, filter|
      options = {:type => filter[:type], :name => filter[:name]}

      options[:remote] = true if filter.remote

      if has_filter?(field) || !filter.remote

        options[:values] = filter.values

Trace of template inclusion: app/views/queries/_query_form.html.erb, app/views/issues/index.html.erb

Rails.root: /Users/noysh/projects/farview/farview-devlink-3.4-stable

Application Trace | Framework Trace | Full Trace

app/models/query.rb:464:in `block in available_filters_as_json'

app/models/query.rb:462:in `each'

app/models/query.rb:462:in `available_filters_as_json'

app/views/queries/_filters.html.erb:4:in `block in _app_views_queries__filters_html_erb__941875204378063440_70

306769152520'

app/views/queries/_filters.html.erb:1:in `_app_views_queries__filters_html_erb__941875204378063440_70306769152

520'

app/views/queries/_query_form.html.erb:10:in `_app_views_queries__query_form_html_erb___1924681068357817272_70

306752298920'

app/views/issues/index.html.erb:11:in `block in _app_views_issues_index_html_erb___4300101081652184242_7030675

2230600'

app/views/issues/index.html.erb:10:in `_app_views_issues_index_html_erb___4300101081652184242_70306752230600'

app/controllers/issues_controller.rb:51:in `block (2 levels) in index'

app/controllers/issues_controller.rb:46:in `index'

lib/redmine/sudo_mode.rb:63:in `sudo_mode'

Request

Parameters:

{"project_id"=>"project_name"}

Toggle session dump

Toggle env dump

Response

Headers:

None

#41 - 2017-10-27 04:19 - Quan VN

Shaun Gilroy wrote:

So is there any chance that the _query plugin getting updated to function with Redmine 3.4? I tried to figure out how to update it, but it's not clear

to me what needs to be changed to make it compatible.

It gives me the following error in 3.4 as is:

[...]

 Dear Shaun

I am sorry. This version of plugin is too old. I create a separate entry for this plugin and put the update here and it works with redmine 3.4

https://www.redmine.org/plugins/boolean_query

Unfortunately I cannot find way to delete this old attachment

Quan

#42 - 2017-10-27 04:21 - Quan VN

- File _query.0.0.3.rm34.zip added

For redmine 3.4, please use the version at

https://www.redmine.org/plugins/boolean_query

Or use new version attached here _query.0.0.3.rm34.zip

#43 - 2017-10-27 20:57 - Shaun Gilroy

Quan VN wrote:

For redmine 3.4, please use the version at

https://www.redmine.org/plugins/boolean_query

Or use new version attached here _query.0.0.3.rm34.zip

 Excellent! Thank you!
#44 - 2017-11-22 09:17 - Roman Yagodin

+1

It could be great to allow filters with multiple conditions by same field (e.g. status is "open" AND status is not feedback) also.

#45 - 2018-04-20 21:18 - name zero

+1 :}

#46 - 2018-04-23 11:56 - name zero

Would it be possible to select the same field twice, so I can query "Due in the next 14 days or due date none" ?

Seems like the field is greyed out once it is selected.

#47 - 2018-08-19 15:44 - mouson chen

+1

#48 - 2019-04-19 00:42 - Jérôme BATAILLE

Hi, I have developed this feature in my company, I will try to bring it as a plugin.

#49 - 2019-08-13 14:07 - Andreas M

is there an plugin version for 4.0? On the plugin site itself it tells me an 404?

Both https://www.redmine.org/plugins/boolean_query

and https://www.redmine.org/plugins/_query deliver 404

#50 - 2019-08-13 15:07 - Tobias Schmidt

As far as I know there is no version for 4.0 available. But you could keep an eye on mbideau/redmine_zquery. There even is an issue for redmine 4.xx

support.

Andreas Michel wrote:

is there an plugin version for 4.0?

#51 - 2019-09-25 09:50 - Emanuel Reisinger

Tobias Schmidt wrote:

As far as I know there is no version for 4.0 available. But you could keep an eye on mbideau/redmine_zquery. There even is an issue for 

redmine 4.xx support.

Andreas Michel wrote:

is there an plugin version for 4.0?

 

But mbideau/redmine_zquery is an older version and does not suppport Redmine 3.4 as _query version 0.0.3 posted in #42 by Quan VN.

#52 - 2019-09-25 09:57 - Emanuel Reisinger

- File _query.0.0.4.redmine4x.tar.gz added

We are using OR filter in our work heavily and I have to upgrade our Ubuntu server and Redmine periodically.

With the last Ubuntu upgrade to 18.04 LTS Ruby 2.5 and Rails 5.2 was introduced. This versions are supported by Redmine 4.x only and I don't want

maintain old versions of Ruby and Rails on our system.

So I have upgrade to Redmine 4.x.

I'm not a Ruby and Ruby on Rails developer but these are my first steps and with help of article 

https://www.justinweiss.com/articles/rails-5-module-number-prepend-and-the-end-of-alias-method-chain/ I could modify the plugin to work with

Redmine 4.x because alias_method_chain and other methods has been removed with Rails 5.

I don't know how to integrate the new Query.operators match and not match in the new plugin implementation because there is no initializer/method

for that.

So I removed these new operators because they are not required for the OR filters and are subjects for a separate plugin or patch to

Query.statement. The latter is to prefer.

The second reason why I removed the new operators is that it's not clear where they come from.

Further I've changed the names of the or filters for a better understandability and moved the text into translation files and added german translations.
Any follow (AND) -> AND any following

Any follow (OR) -> OR any following

All follow (OR) -> OR all following

You can easily change the names by updating plugins/_query/config/locals/en.yml or adding further translations if you desire.

So I offer a plugin update for Redmine 4, see _query.0.0.4.redmine4x.tar.gz. Tested on Ubuntu 18.04 with Redmine 4.0.4.

I don't think that the plugin works with Redmine 3.4 because of the modifications besides alias_method_chain. I havn't tested it with Redmine 3.4.

By the way the implementation is really a quick and dirty hack because it overwrites the Query.statement method. Any changes in the core

Query.statement implementation won't be considered by this plugin unless an update is made.

I'll try to create a patch to Redmine core with functionality as this plugin provides, so that this plugin is not required any longer.

#53 - 2019-09-25 12:17 - giorgio rossi

Thanks for Your work.

Unfortunately the two methods match and not match introduce the logical operators inside the string fields. For example, if I want to search for a more

then a string in a field in OR:

Description match string1 ~ string2 ~ string3 ~ string4

I obtain as result all issues that contain at least one of the four strings in field Description

#54 - 2019-09-26 18:00 - Emanuel Reisinger

giorgio rossi wrote:

Thanks for Your work.

Unfortunately the two methods match and not match introduce the logical operators inside the string fields. For example, if I want to search for a

more then a string in a field in OR:

Description match string1 ~ string2 ~ string3 ~ string4

I obtain as result all issues that contain at least one of the four strings in field Description

 I've read the readme and now understand what the operators match and not match do.

They have nothing to do with the or filters but are useful extensions for the queries. But I still don't know how to implement the new operators in the

_query plugin. Sorry.

#55 - 2019-09-26 19:01 - Emanuel Reisinger

- File _query.0.0.5.redmine4x.tar.gz added

I've found a simple solution to get match operators implemented in _query plugin.

So container _query.0.0.5.redmine4x.tar.gz includes or filters and match operators that works with Redmine 4.x.

#56 - 2019-10-07 18:08 - Emanuel Reisinger

- File issue4939_orfilter.patch added

- File issue4939_match_operators.patch added

- File README.txt added

I've made patches to integrate the or filters and match operators into redmine core.

So the _query plugin is obsolete with this patches.

The provided patch files has to be applied in the correct order and are based on svn revision 18620. First, issue4339_orfilter.patch and then

issue4939_match_operators.patch.

The usage of or-filter and match operators should be added to the Redmine wiki [[https://www.redmine.org/projects/redmine/wiki/RedmineIssueList]]

because without an usage descriptions the full power of the match operators are unknown. Therefore I added the README.txt of _query plugin which

describes it.

#57 - 2019-10-15 17:15 - giorgio rossi

Fantastic job!!

Thanks You

#58 - 2019-12-02 23:00 - Jochen Kuehner

2025-05-01 7/13

https://www.redmine.org/projects/redmine/wiki/RedmineIssueList


Is anybody in contact with Jean-Philippe Lang so this has a change to get merged?

The filter options need to be much more poerfull...

#59 - 2019-12-02 23:06 - Jérôme BATAILLE

Hi,

Can you put some screen captures to be able to see how it works and how it changes the native behavior ?

#60 - 2019-12-03 10:13 - Emanuel Reisinger

- File screencapture_matchop_match-complex.jpg added

- File screencapture_matchop_match-simple.jpg added

- File screencapture_matchop_notmatch-simple.jpg added

- File screencapture_orfilter.jpg added

- File screencapture_matchop_all-issues.jpg added

All issues

All issues to compare the examples:

 screencapture_matchop_all-issues.jpg 

Or filter example

One of the or filter (AND any following) in action. In the Add filter dropdown they are grouped in section OR filters.

In the filter section Author and Assignee are added to the or filter AND any following (AND (Author OR Assignee)). The result shows the issues where

Dave Lopper is either Assignee or Author.

 screencapture_orfilter.jpg 

Match operator examples

Please see README.txt that describes the usage of or filter and match operators.

A simple example that uses the match filter:

 screencapture_matchop_match-simple.jpg 

A simple example that uses the not match filter, the opposite of simple match filter example:

 screencapture_matchop_notmatch-simple.jpg 

A more complex example that uses the match filter:

 screencapture_matchop_match-complex.jpg 

I hope this screen captures helps.

#61 - 2019-12-03 10:53 - Jérôme BATAILLE

Thanks Emanuel

#62 - 2019-12-03 10:53 - Jérôme BATAILLE

+1

#63 - 2019-12-27 07:51 - name zero

I second that, JPL (or someone with equivalent competency) should review and merge.

This is extremely useful!

#64 - 2019-12-30 17:31 - Yuuki NARA

Thanks for useful patch.

http://www.redmine.org/issues/4939#note-56

I hope a lot of people have confirmed that this feature works and get it incorporated into RedmineCore as soon as possible.

However, the latest trunk rev19405 could not apply this patch.

To make it easier to try, I created a branch on my repository and patched it.

https://github.com/y503unavailable/redmine/tree/feature-patch4939

https://github.com/redmine/redmine/compare/master...y503unavailable:feature-patch4939.patch
In this code, I checked the operation of the or-filter function.

I added a Japanese term file patch.

But,created Tentatively.

The following branch publishes the 4.2-stable with this issue and the patch of issue 5358 applied.

I update every month for the latest trunk.

https://github.com/y503unavailable/redmine/tree/feature-unofficialcooking

Share Issues Categories for sub-projects

https://www.redmine.org/issues/5358

#65 - 2020-03-25 12:19 - Robert Röttger

+1 for this feature

#66 - 2020-04-08 07:34 - Martin Erler

+1 for this feature (to create a simple filter: assignee OR watcher)

#67 - 2020-08-25 07:46 - Pawel Orzechowski

Yes, yes, yes +1 :-) ;-)

#68 - 2020-09-03 09:03 - Anonymous

Being able to set the boolean operators would be very useful

+1 for this feature

#69 - 2020-10-20 11:45 - Ray Cheung

Johannes Heymann wrote:

Being able to set the boolean operators would be very useful

+1 for this feature

 +1 for this feature

#70 - 2020-11-03 20:44 - Txinto Vaz

+1 too

#71 - 2020-11-12 14:23 - Alexandr Chernyaev

+1

#72 - 2020-11-21 10:45 - Michael Aram

+1

#73 - 2021-02-04 03:09 - Sunding Wei

+1, I want this feature too!

2021-02-04:

I merge the patch into latest Redmine 4.x with a branch called logical-filters, check it out here

https://github.com/sweihub/redmine/tree/logical-filters

But still pity for each filter can only be used once.

#74 - 2021-02-23 12:29 - Holger Just

- Has duplicate Feature #34793: Filter OR / AND for issues and repeated columns in filter settings added

#75 - 2021-02-25 10:09 - Micael Broun

https://www.redmine.org/issues/4939#note-56

for this patch really need ability to use the same column more than once

for be able to use simple filter like

Target OR Target

And espessially for OR in Tags - really can't use this feature for full without deep filtration
#76 - 2021-07-05 12:26 - Fabrizio Sebastiani

+1

Not clear to me whether this feature have been incorporated into the RedmineCore or not (?)

#77 - 2021-09-02 10:01 - txemi M

+1

+1

+1

#78 - 2022-01-07 16:18 - Andrea Valle

+1

#79 - 2022-01-09 17:04 - Erik S.

+1 for this but more logical operators for filters in general also multiple conditions for the same field.

How can this basic functionality not have been prioritized after all these years (11 years!)?

I'm trying to create filters to create a simple Eisenhower Matrix: [[https://todoist.com/productivity-methods/eisenhower-matrix]] with the help of 

tags

but I fail since cannot create the condition:

tag is "Important" AND tag is "Urgent"

for a logical AND. But I can only create a logical OR.    

Please prioritize!

#80 - 2022-01-24 11:44 - Jannis Hübl

+1

+1

#81 - 2022-03-24 09:28 - Igor M

+1

#82 - 2022-03-29 20:35 - Peter ILLETSCHKO

+1

#83 - 2022-03-30 14:37 - Mr. Míng

+1

#84 - 2022-04-13 19:57 - stéphane plaissy

+1

#85 - 2022-04-20 10:16 - Vladimir Bocharov

+1

#86 - 2022-04-29 19:02 - Vito Marolda

+1

#87 - 2022-05-22 08:14 - hagay go

Hi everyone,

Tried/tested an upgrade to redmine 5.0.1.

The _query.0.0* plugins does not seem to work on redmine 5.0.X (at least for me) :

/usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader/callbacks.rb:25:in `on_file_autoloaded': expected fi

le /usr/src/redmine/plugins/_query/lib/query_patch4.rb to define constant QueryPatch4, but didn't (Zeitwerk::N

ameError)
      raise Zeitwerk::NameError.new("expected file #{file} to define constant #{cpath}, but didn't", cref.last

)

      ^^^^^

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/kernel.rb:28:in `require'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader/helpers.rb:95:in `const_get'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader/helpers.rb:95:in `cget'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader.rb:237:in `block (2 levels) in eager_lo

ad'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader/helpers.rb:26:in `block in ls'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader/helpers.rb:18:in `each_child'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader/helpers.rb:18:in `ls'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader.rb:232:in `block in eager_load'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader.rb:217:in `synchronize'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader.rb:217:in `eager_load'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader.rb:317:in `each'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/loader.rb:317:in `eager_load_all'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/application/finisher.rb:133:in `block in <module:

Finisher>'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/initializable.rb:32:in `instance_exec'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/initializable.rb:32:in `run'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/initializable.rb:61:in `block in run_initializers

'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:228:in `block in tsort_each'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:350:in `block (2 levels) in each_strongly_connected_component'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:431:in `each_strongly_connected_component_from'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:349:in `block in each_strongly_connected_component'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:347:in `each'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:347:in `call'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:347:in `each_strongly_connected_component'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:226:in `tsort_each'

        from /usr/local/lib/ruby/3.1.0/tsort.rb:205:in `tsort_each'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/initializable.rb:60:in `run_initializers'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/application.rb:391:in `initialize!'

        from /usr/src/redmine/config/environment.rb:16:in `<top (required)>'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/kernel.rb:35:in `require'

        from /usr/local/bundle/gems/zeitwerk-2.5.4/lib/zeitwerk/kernel.rb:35:in `require'

        from /usr/local/bundle/gems/activesupport-6.1.6/lib/active_support/dependencies.rb:332:in `block in re

quire'

        from /usr/local/bundle/gems/activesupport-6.1.6/lib/active_support/dependencies.rb:299:in `load_depend

ency'

        from /usr/local/bundle/gems/activesupport-6.1.6/lib/active_support/dependencies.rb:332:in `require'

        from config.ru:3:in `block in <main>'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/builder.rb:116:in `eval'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/builder.rb:116:in `new_from_string'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/builder.rb:105:in `load_file'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/builder.rb:66:in `parse_file'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/server.rb:349:in `build_app_and_options_from_config'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/server.rb:249:in `app'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/server.rb:422:in `wrapped_app'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/server.rb:312:in `block in start'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/server.rb:379:in `handle_profiling'

        from /usr/local/bundle/gems/rack-2.2.3/lib/rack/server.rb:311:in `start'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/commands/server/server_command.rb:39:in `start'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/commands/server/server_command.rb:144:in `block i

n perform'

        from <internal:kernel>:90:in `tap'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/commands/server/server_command.rb:135:in `perform

'

        from /usr/local/bundle/gems/thor-1.2.1/lib/thor/command.rb:27:in `run'

        from /usr/local/bundle/gems/thor-1.2.1/lib/thor/invocation.rb:127:in `invoke_command'

        from /usr/local/bundle/gems/thor-1.2.1/lib/thor.rb:392:in `dispatch'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/command/base.rb:69:in `perform'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/command.rb:48:in `invoke'

        from /usr/local/bundle/gems/railties-6.1.6/lib/rails/commands.rb:18:in `<top (required)>'

        from bin/rails:4:in `require'

        from bin/rails:4:in `<main>'

 Any chance to create/point to an updated version of the plugin ?

Thanks in advance.

#88 - 2022-05-27 20:20 - Tilman Klaeger

- File Redmine5.0.1-or-query-patch.patch added
Hello, i tried to apply the patch proposed by Sunding Wei in #4939-73 to the latest Redmine (5.0.1) and it looks like working. I’m not a Ruby pro

though.

This seems to be the latest version of what used to be a plugin. And at least on Redmine 4.1 this worked very well. Thanks to everyone for former

contributions!!!

See the patch (exported with git format-patch) attached: Redmine5.0.1-or-query-patch.patch

#89 - 2022-05-29 07:13 - hagay go

Hi , thanks for the info.

If i understand you correctly , the patch is "fixing" redmine to work with old redmine version of the plugin ?

While this might be usable for others , for me at least , I cant use patches on redmine itself and need to wait for an updated plugin version.

#90 - 2022-05-30 20:15 - Tilman Klaeger

hagay go wrote:

If i understand you correctly , the patch is "fixing" redmine to work with old redmine version of the plugin ?

 The patch inserts the functionality of the older plugin right into Redmine, no plugin needed at all afterwards.

While this might be usable for others , for me at least , I cant use patches on redmine itself and need to wait for an updated plugin version.

 I’m afraid I can’t help on this one. But maybe someone else can chime in and help.

#91 - 2022-11-17 02:34 - John Wang

+1

I need it sooo much.

#92 - 2022-12-16 14:12 - thuruk thuruk

+1 ! Redmine has some glaringly missing functionalities, and this is one of them.

#93 - 2023-06-06 02:08 - Ivan Zakrevsky

See for example https://github.com/jamerst/o-data-grid

#94 - 2023-11-12 14:11 - Yasu Saku

- File or-query-patch-for-Redmine-5.1.0.patch added

+1

I attempted to update the or-query-path based on post #4939-88 for Redmine 5.1.0.

I hope it proves helpful.

#95 - 2024-03-14 16:09 - Holger Just

- Has duplicate Feature #13356: Disjunction for issues filters added

#96 - 2024-05-07 19:57 - Cécile Ichard

Could you please clarify if this feature is now integrated in redmine-core ? If yes which version ?

In the contrary, could you please indicate what is the procedure to follow ?

#97 - 2024-07-31 15:46 - Ammar Hakim

Cécile Ichard wrote in #note-96:

Could you please clarify if this feature is now integrated in redmine-core ? If yes which version ?

In the contrary, could you please indicate what is the procedure to follow ?

 This feature is not integrated with the core installation.

I was able to get it working on version 5.1.2 by doing the following:

1. Downloading and untar _query.0.0.4.redmine4x.tar.gz attachment into redmine/plugins

2. Download the patch file or-query-patch-for-Redmine-5.1.0.patch

3. Patch the plugin using the following command while remaining in the redmine directory
patch -p1 < or-query-patch-for-Redmine-5.1.0.patch 

4. Create a new directory called redmine_or_filter under redmine/plugin/_query/lib

5. Move the query_patch4.rb file from redmine/lib into the new redmine_or_filter directory.

6. Replace any module definitions within the query_patch4.rb file from QueryPatch to QueryPatch4

7. Run your server    

Also you may have to migrate your db for the menu to show correctly as in the image from the original post. I used the following 2 commands for the 

development instance (not production), not sure entirely why/what it does do it at your own risk I am not a Rails or Redmine professional.

RAILS_ENV=development rake db:migrate

bundle exec rake redmine:plugins:migrate

More info here:

https://www.redmine.org/projects/redmine/wiki/Plugins

#98 - 2024-09-05 05:05 - Takenori TAKAKI

Allowing users to use the OR logical operator will let them filter issues under more varied conditions.

I respect the code proposals and discussions in this issue.

To support this goal, I’ve proposed a patch in a new issue, #41214,

that directly addresses the OR condition written in this issue's description ( filter1=value1 OR filter2=value2 OR filter3=value3 ).

Please take a look if you're interested.

#99 - 2024-09-05 06:52 - Go MAEDA

- Related to Feature #41214: Allow the 'OR' Logical Operator in Query added

#100 - 2024-09-15 13:40 - Jakob Schlanstedt

Filters without the `OR` operator are inherently limited. Every logical formula can be expressed in Disjunctive Normal Form (DNF), which means

combining multiple conditions using `OR`.

For instance, a logical expression like (A ^ B ^ C) V (D ^ E ^ F ^ G) V (H ...)\) showcases how `OR` is used to combine various statements.

Without `OR`, you can’t represent such combinations. Imagine you need a filter that passes items if Condition A, Condition B, or Condition C is true.

This is expressed as (A V B V C). Without the `OR` operator, it’s impossible to create this filter, severely limiting the complexity and effectiveness of

the filtering mechanisms.

I think this should be implemented in Base Redmine just because of that.

#101 - 2024-12-20 11:20 - Alexey Smirnov

Development plugin based on discussion

https://www.redmine.org/plugins/redmine_or_plugin

#102 - 2025-03-11 15:11 - Csaba Nyéki

+1

Files

Redmine using OR.zip 11.5 KB 2013-09-19 Quan VN

_query.zip 3.56 KB 2015-11-20 Quan VN

_query.0.0.3.rm34.zip 4.38 KB 2017-10-27 Quan VN

_query.0.0.4.redmine4x.tar.gz 3.17 KB 2019-09-25 Emanuel Reisinger

_query.0.0.5.redmine4x.tar.gz 3.75 KB 2019-09-26 Emanuel Reisinger

issue4939_orfilter.patch 9.64 KB 2019-10-07 Emanuel Reisinger

issue4939_match_operators.patch 6.21 KB 2019-10-07 Emanuel Reisinger

README.txt 2.72 KB 2019-10-07 Emanuel Reisinger

screencapture_matchop_match-complex.jpg 25.3 KB 2019-12-03 Emanuel Reisinger

screencapture_matchop_match-simple.jpg 33.1 KB 2019-12-03 Emanuel Reisinger

screencapture_matchop_notmatch-simple.jpg 31.9 KB 2019-12-03 Emanuel Reisinger

screencapture_orfilter.jpg 72.3 KB 2019-12-03 Emanuel Reisinger

screencapture_matchop_all-issues.jpg 55.5 KB 2019-12-03 Emanuel Reisinger

Redmine5.0.1-or-query-patch.patch 16 KB 2022-05-27 Tilman Klaeger

or-query-patch-for-Redmine-5.1.0.patch 15.9 KB 2023-11-12 Yasu Saku
